/* playlistDialog.h

   Copyright (C) 1999 by David Rose.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   To contact the original author of this program, write to:
           David Rose
           224 W. Dryden St Apt. 418
	   Glendale, CA 91202
	   USA

	   drose@lafn.org
   */

#ifndef PLAYLISTDIALOG_H
#define PLAYLISTDIALOG_H

#include "palomaDialog.h"
#include "dataset.h"
#include "dataCell.h"
#include "playlistProxy.h"
#include "playlistControls.h"

#include <gtk--.h>
#include <string>
#include <vector>
#include <set>

class SongDialog;


class PlaylistDialog : public PalomaDialog {
public:
  PlaylistDialog(const Dataset &data, int form_id, 
		 const PlaylistProxy &playlist);
  ~PlaylistDialog();

  // This is a convenience function, to make a dialog directly from a
  // SQL command.
  static PlaylistDialog *make_dialog(const Dataset &data, int form_id, 
				     const string &sql_command);

  bool is_playable() const;

  void menu_get_songs();
  void menu_export();

private:
  void playlist_ended();
  void shuffle_button_clicked();
  void remove_button_clicked();
  void cancel_button_clicked();

  void layout_window();

  Gtk_ItemFactory_MenuBar _menu;
  Gtk_ObjectHandle<Gtk_MenuBar> _menubar;
  Gtk_VBox _box1;
  Gtk_ScrolledWindow _sc_window;
  Gtk_CList *_clist;
  Gtk_HBox _cbox;
  PlaylistControls _controls;
  Gtk_Button _shuffle_button;
  Gtk_VBox _checks;
  Gtk_CheckButton _repeat_check;
  Gtk_CheckButton _shuffle_check;
  Gtk_Button _songs_button;
  Gtk_Button _remove_button;
  Gtk_Button _cancel_button;

  int _form_id;

  PlaylistProxy _playlist;
};

#endif

